HDU-5542-The Battle of Chibi(树状数组+数位dp)

        Time Limit: 6000/4000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)

Problem Description 
Cao Cao made up a big army and was going to invade the whole South China. Yu Zhou was worried about it. He thought the only way to beat Cao Cao is to have a spy in Cao Cao’s army. But all generals and soldiers of Cao Cao were loyal, it’s impossible to convince any of them to betray Cao Cao.

So there is only one way left for Yu Zhou, send someone to fake surrender Cao Cao. Gai Huang was selected for this important mission. However, Cao Cao was not easy to believe others, so Gai Huang must leak some important information to Cao Cao before surrendering.

Yu Zhou discussed with Gai Huang and worked out N information to be leaked, in happening order. Each of the information was estimated to has ai value in Cao Cao’s opinion.

Actually, if you leak information with strict increasing value could accelerate making Cao Cao believe you. So Gai Huang decided to leak exact M information with strict increasing value in happening order. In other words, Gai Huang will not change the order of the N information and just select M of them. Find out how many ways Gai Huang could do this.

Input 
The first line of the input gives the number of test cases, T(1≤100). T test cases follow.

Each test case begins with two numbers N(1≤N≤103) and M(1≤M≤N), indicating the number of information and number of information Gai Huang will select. Then N numbers in a line, the ith number ai(1≤ai≤109) indicates the value in Cao Cao’s opinion of the ith information in happening order.

Output 
For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the ways Gai Huang can select the information.

The result is too large, and you need to output the result mod by 1000000007(109+7).

Sample Input 

3 2 
1 2 3 
3 2 
3 2 1

Sample Output 
Case #1: 3 
Case #2: 0

Hint

In the first cases, Gai Huang need to leak 2 information out of 3. He could leak any 2 information as all the information value are in increasing order. 

In the second cases, Gai Huang has no choice as selecting any 2 information is not in increasing order.

题目大意:给出长度为n的序列,问这个序列中有多少个长度为m的单调递增子序列。

题目思路:dp[i][j],表示到第i个数字,长度为j的单调递增子序列的个数。需要注意的是取第j个数字。

  for (int i = 0; i < n; i++)               //o(n^3)的复杂度,一定会超时,用树状数组优化
        {
            dp[i][1] = 1;
        }
        for (int i = 1; i < n; i++)
        {
            for (int j = 1; j <= min(i+1,m); j++)
            {
                for (int k = i - 1; k >= 0; k--)
                {
                    if (num[k] < num[i])                            //子序列严格单调递增
                        dp[i][j] = (dp[i][j] + dp[k][j - 1]) % MOD;
                }
            }
        }
用dp[i][j]表示前i个数中选择了j个数的上升子序列的方案数。 
这个状态的一个好处是,它把这个上升自序列的长度也包含了,就是j。 
还有一个性质,我们如何查看一个数能否接在前面的序列后?其实只要知道之前上升子序列的最后一位就可以进行判定了。 
鉴于这个,我们修改下dp[i][j]的含义——dp[i][j]表示前i个数中选择了j个数,且最后一个数严格为a[i]时的上升子序列方案数。 
这样就有状态转移dp[i][j]=∑dp[k][j-1],p∈[1,i-1]且num[k]<num[i] 
 因为我们可以严格保持i的升序,所以就只需要找到所有长度为j-1且尾节点num[k]<num[i]的子序列个数即可

树状数组还是不太懂,之所以转这篇文章是为了让自己学习一下上面的算法!!

#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <string>
#include <cstring>
using namespace std;
#define MOD 1000000007
#define  lowbit(x)  ((x) & -(x))
int num[1010];
int dp[1010][1010];
int b[1010];
int n,m;
int sum(int x,int y)   //计算y长度的子序列,前x项有多少种情况的和
{
    int ret = 0;
    while(x > 0)
    {
        ret = (ret + dp[x][y]) % MOD;
        x -= lowbit(x);
    }
    return ret;
}
void add(int x,int y,int d)  //更新x及以上长度,能取到的y的值为d
{
    while(x <= n)
    {
        dp[x][y] = (dp[x][y] + d) % MOD;
        x += lowbit(x);
    }
}
int main(){
    int t;
    scanf("%d",&t);
    int cnt = 1;
    while(t--)
    {

        scanf("%d%d",&n,&m);
        memset(dp,0,sizeof(dp));
        for (int i = 1; i <= n; i++)
        {
            scanf("%d",&num[i]);
            b[i] = num[i];
        }
        sort(b + 1,b + 1 + n);
        for (int i = 1; i<= n; i++)
        {
            num[i] = lower_bound(b + 1, b + 1 + n, num[i]) - b;  //num[i]存储的是该位置是第几大的元素
        }
        for (int i = 1; i <= n; i++)
        {
            for (int j = 1; j <= min(i+1,m); j++)
            {
                if (j == 1) add(num[i],1,1);
                else
                {
                    int temp = sum(num[i] - 1,j - 1);
                    add(num[i],j,temp);
                }
            }
        }
        printf("Case #%d: %d\n",cnt++,sum(n,m));
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/asd1637579311/article/details/80160424